/*
 * $Id: Parameters_print.cpp 81 2008-04-15 18:40:01Z rosiere $
 *
 * [ Description ]
 * 
 */

#include "Behavioural/Core/Multi_OOO_Engine/OOO_Engine/Rename_unit/Register_translation_unit/Free_List_unit/include/Parameters.h"
#include "Behavioural/include/XML.h"

namespace morpheo                    {
namespace behavioural {
namespace core {
namespace multi_ooo_engine {
namespace ooo_engine {
namespace rename_unit {
namespace register_translation_unit {
namespace free_list_unit {


#undef  FUNCTION
#define FUNCTION "Free_List_unit::print"
  std::string Parameters::print (uint32_t depth)
  {
    log_printf(FUNC,Free_List_unit,FUNCTION,"Begin");

    XML xml ("free_list_unit");

    xml.balise_open("free_list_unit");
    xml.singleton_begin("nb_thread          "); xml.attribut("value",toString(_nb_thread          )); xml.singleton_end();
    xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
    xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
    xml.singleton_begin("nb_bank            "); xml.attribut("value",toString(_nb_bank            )); xml.singleton_end();
    xml.singleton_begin("nb_pop             "); xml.attribut("value",toString(_nb_pop             )); xml.singleton_end();
    xml.singleton_begin("nb_push            "); xml.attribut("value",toString(_nb_push            )); xml.singleton_end();
    xml.balise_close();

    log_printf(FUNC,Free_List_unit,FUNCTION,"End");
    
    return xml.get_body(depth);
  };

#undef  FUNCTION
#define FUNCTION "Free_List_unit::operator<<"
  std::ostream& operator<< (std::ostream& output_stream ,
			    morpheo::behavioural::core::multi_ooo_engine::ooo_engine::rename_unit::register_translation_unit::free_list_unit::Parameters & x)
  {
    log_printf(FUNC,Free_List_unit,FUNCTION,"Begin");

    output_stream << x.print(0);
    
    log_printf(FUNC,Free_List_unit,FUNCTION,"End");

    return output_stream;
  };

}; // end namespace free_list_unit
}; // end namespace register_translation_unit
}; // end namespace rename_unit
}; // end namespace ooo_engine
}; // end namespace multi_ooo_engine
}; // end namespace core

}; // end namespace behavioural
}; // end namespace morpheo              
